﻿// hello.cpp내

#include "stdafx.h"
#include "Resource.h"
#include "tipupdater_trayicon.h"
#include <windows.h>

CComModule _Module;

const TCHAR IDS_PROGRAM_NAME[] = _T("NTalkBiz Update");

const TCHAR IDS_NTOOLSUPDATER_TRAY_CLASS[] = _T("TrayIconHandler");
const TCHAR IDS_NTOOLSUPDATER_TRAY_TITLE[] = _T("");
const TCHAR IDS_UPDATE_MSG[] = _T("프로그램 설치/업데이트/삭제 완료 후, 트레이 아이콘 메뉴를 사용해 주시기 바랍니다.");

const int MSGFLT_ADD = 1;
const int MSGFLT_REMOVE = 2;

const UINT WM_TRAYICON_SHOW_CONFIG = WM_USER+111;
const UINT WM_TRAYICON_QUIT_NTOOLSUPDATER = WM_USER+112;
const UINT WM_TRAYICON_SHOW_NTOOLSUPDATER = WM_USER+113 ;
const UINT WM_TRAYICON_HIDE_TRAYICON = WM_USER+114;

const UINT TIMER_CHECK_UPDATER_LIVE_EVENT = 1000;

int WINAPI _tWinMain(HINSTANCE hInstance, HINSTANCE, LPTSTR lpCmdLine, int nCmdShow)
{
	_Module.Init(NULL, hInstance);

	// 독자 윈도우를 작성
	CTrayWindow wnd;
	wnd.Create(NULL, CWindow::rcDefault,
		_T("네이버 툴즈 업데이트"), WS_OVERLAPPEDWINDOW );

	MSG msg;
	while(GetMessage(&msg, NULL, 0, 0) > 0){
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

	_Module.Term();
	return msg.wParam;
}

BOOL CTrayWindow::Show()
{
	m_TrayIcon = new CTrayIcon;
	if( NULL == m_TrayIcon )
		return FALSE;

	HICON hIcon = LoadIcon( _Module.get_m_hInst(), MAKEINTRESOURCE(IDI_TIPUPDATER_TRAYICON) );
	m_TrayIcon->Create( this->m_hWnd, WM_TRAY_NOTIFY, IDS_PROGRAM_NAME, hIcon, WM_TRAY_NOTIFY );
	return TRUE;
}

void CTrayWindow::Hide()
{
	if( m_TrayIcon )
	{
		m_TrayIcon->RemoveIcon();
		delete m_TrayIcon;
		m_TrayIcon = NULL;
	}
}

void CTrayWindow::Restart()
{
	if( m_bTrayStatus )
	{
		Hide();
		Show();
	}
}

LRESULT CTrayWindow::OnTimer(UINT nMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	if( wParam == TIMER_CHECK_UPDATER_LIVE_EVENT )
	{
		m_hMainHwnd = ::FindWindowEx( HWND_MESSAGE, NULL, NULL , IDS_NTOOLSUPDATER_TRAY_CLASS );
		if( NULL == m_hMainHwnd)
		{
			PostQuitMessage(0);
		}
	}

	return 1;
}

LRESULT CTrayWindow::OnQuit(WORD w1, WORD w2, HWND hWnd, BOOL& bHandled)
{
	SendMessageToNToolsUpdater( WM_TRAYICON_QUIT_NTOOLSUPDATER );
	Hide();
	PostQuitMessage(0);
	return 1;
}

LRESULT CTrayWindow::OnShowConfig(WORD w1, WORD w2, HWND hWnd, BOOL& bHandled)
{
	SendMessageToNToolsUpdater( WM_TRAYICON_SHOW_CONFIG );
	return 1;
}

LRESULT CTrayWindow::OnViewOpen(WORD w1, WORD w2, HWND hWnd, BOOL& bHandled)
{
	SendMessageToNToolsUpdater( WM_TRAYICON_SHOW_NTOOLSUPDATER );
	return 1;
}

LRESULT CTrayWindow::OnTrayHide(WORD w1, WORD w2, HWND hWnd, BOOL& bHandled)
{
	SendMessageToNToolsUpdater( WM_TRAYICON_HIDE_TRAYICON );
	return 1;
}

UINT CTrayWindow::SendMessageToNToolsUpdater( UINT msg )
{
	return ::SendMessage( m_hMainHwnd, msg, 0, 0 );
}

BOOL CTrayWindow::IsUpdating()
{
	return m_bIsUpdate;
}

LRESULT CTrayWindow::OnTrayIconCallback(UINT nMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	// context menu example
	if( LOWORD(lParam) == WM_RBUTTONUP )
	{
		if( IsUpdating() == TRUE )
			return 1;

		CPoint pt;
		CMenu menuTemp;
		CMenuHandle contextMenu;
		GetCursorPos(&pt);
		if( menuTemp.LoadMenu(IDR_TRAYICON_POPUP) )
		{
			contextMenu = menuTemp.GetSubMenu(0);
			SetForegroundWindow(this->m_hWnd);
			contextMenu.TrackPopupMenu(TPM_RIGHTALIGN | TPM_LEFTBUTTON, pt.x, pt.y, this->m_hWnd, NULL);
			PostMessage(WM_NULL);
		}
	}
	else if (LOWORD(lParam) == WM_LBUTTONDBLCLK)
	{
		SendMessageToNToolsUpdater( WM_TRAYICON_SHOW_NTOOLSUPDATER );
		return 1;
	}
	return 1;
}

LRESULT CTrayWindow::OnCreate(UINT msg, WPARAM wParam, LPARAM lParam, BOOL& bHandle)
{
	if( NULL == ::CreateMutex( NULL, TRUE, _T("tipupdater_trayicon") ) )
	{
		PostQuitMessage(0);
		return 0;
	}

	if ( GetLastError() == ERROR_ALREADY_EXISTS )
	{
		::MessageBox( NULL, _T("Mutex"), _T("Error"), 0);
		PostQuitMessage(0);
		return 0;
	}

	WM_TASKBARCREATED = ::RegisterWindowMessage(_T("TaskbarCreated")) ;
	Show();
// 	m_hMainHwnd = ::FindWindowEx( HWND_MESSAGE, NULL, NULL , IDS_NTOOLSUPDATER_TRAY_CLASS );
// 	if( NULL == m_hMainHwnd )
// 	{
// 		PostQuitMessage(0);
// 	}
// 
// 	SetTimer( TIMER_CHECK_UPDATER_LIVE_EVENT, 1000, NULL );
	return 1;
}

LRESULT CTrayWindow::OnUpdate(UINT msg, WPARAM wParam, LPARAM lParam, BOOL& bHandle)
{
	m_bIsUpdate = (BOOL)lParam;
	if ( m_bIsUpdate )
	{
		if( m_TrayIcon ) 
			m_TrayIcon->SetTooltipText(IDS_UPDATE_MSG);
	}
	else
	{
		if( m_TrayIcon )
			m_TrayIcon->SetTooltipText(IDS_PROGRAM_NAME);
	}
	return 1;
}

LRESULT CTrayWindow::OnUpdaterTrayIconStatus(UINT nMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	m_bTrayStatus = lParam;
	return 1;
}

LRESULT CTrayWindow::OnShowFromNtoolsUpdater(UINT nMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	if( IsShow() )
		return 1;

	Show();
	return 1;
}

LRESULT CTrayWindow::OnHideFromNtoolsUpdater(UINT nMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	if( IsShow() )
		Hide();

	return 1;
}